﻿using System;

namespace SamMok
{
    public class Program
    {
        static void Main(string[] args)
        {
            int[, ] table = new int[, ] { { 0, 1, 2 }, { 3, 4, 5 }, { 6, 7, 8 }, { 0, 3, 6 }, { 1, 4, 7 }, { 2, 5, 8 }, { 0, 4, 8 }, { 2, 4, 6 } };
            Mok[] moks = new Mok[9];
            Mok.Color gameState = Mok.Color.Black;
            while(true)
            {
                Console.WriteLine("삼목 게임에 오신 것을 환영합니다.");
                Console.WriteLine("제작자: 강준구(wnsrn3436@naver.com)\n\n");
                Console.WriteLine(gameState.ToString() + "의 차례입니다.\n");
                for(int i=0; i<9; i++)
                {
                    if (moks[i] == null){
                        Console.Write(("[" + (i + 1) + "]").PadRight(5, ' '));
                    }
                    else{
                        Console.Write((" " + (moks[i].GetColor().ToString())[0] + " ").PadRight(5, ' '));
                    }
                    if (i % 3 == 2){
                        Console.WriteLine("");
                    }
                }
                int index = 0;
                do{
                    Console.Write("\n말을 놓을 곳: ");
                    try{
                        index = int.Parse(Console.ReadLine());
                        if (moks[index - 1] == null) {
                            break;
                        }
                    }catch{
                        continue;
                    }
                } while (true);
                moks[index - 1] = new Mok();
                moks[index - 1].SetColor(gameState);
                bool isBreak = false;
                for(int i=0; i<table.GetUpperBound(0); i++)
                {
                    if ((moks[table[i, 0]]==null) || (moks[table[i, 1]]==null) || (moks[table[i, 2]]==null)){
                        continue;
                    }
                    if (moks[table[i, 0]].GetColor()==moks[table[i, 1]].GetColor() && moks[table[i, 0]].GetColor()==moks[table[i, 2]].GetColor())
                    {
                        Console.WriteLine("\n\n축하합니다." + gameState.ToString() + "(이)가 이겼습니다!\n");
                        isBreak = true;
                        break;
                    }
                }
                if (isBreak){
                    break;
                }
                gameState = (gameState == Mok.Color.Black) ? Mok.Color.White : Mok.Color.Black;
                Console.Clear();
            }
            Console.ReadLine();
        }
    }

    public class Mok
    {
        public enum Color
        {
            Black, 
            White
        }
        private Color Style;
        public void SetColor(Color color)
        {
            Style = color;
        }
        public Color GetColor()
        {
            return Style;
        }
    }
}